unit umain;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics, System.DateUtils,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, Vcl.Buttons, System.ImageList, System.Win.ComObj,
  Vcl.ComCtrls, System.UITypes, Vcl.ExtCtrls, System.StrUtils, Winapi.ActiveX, Winapi.CommCtrl, System.JSON,
  Vcl.ImgList, ERStudio_TLB, Vcl.ColorGrd, System.Win.Registry, REST.Utils, Winapi.ShellAPI, Winapi.tlHelp32,
  System.Net.URLClient, System.Net.HttpClient, System.Net.HttpClientComponent, Vcl.clipbrd,
  Vcl.ExtDlgs, Vcl.Samples.Spin;

{$REGION 'resourcestring'}
resourcestring
  NO_ERDA                     = 'ER/Studio Data Architect is not installed!';
  NO_DATAFLOW                 = 'There is no DataFlow in this Diagram!';
  NO_DIAGRAM                  = 'No diagram currently opened.';
  NB_ATTRIBUTES               = 'Nb Attributes: ';
  NO_DICO                     = 'There''s no DD!';
  OPEN_DIAGRAM                = 'Do you want to open one now?';
  NO_REPO_CONNECT             = 'Cannot connect to the repository:';
  DEFAULT_TRANSFORMATION_TYPE = '[default]';
  NB_ENTITIES                 = '%s - Entities in %s: %d';
  NB_UDTS                     = '%s - UDT in %s: %d';
  NB_ATTACHMENTS              = '%s - Attachments in %s: %d';
  NB_SECURITIES               = '%s - Data Security Information in %s: %d';
  NB_ATTACHMENTS_CREATED      = '%s - Attachments created in %s: %d';
  NB_SECURITIES_CREATED       = '%s - Data Security Information created in %s: %d';
  ENTITIES_CREATED            = '%d entities and %d relationships have been created in a new diagram/model/submodel.';
  REVERSED_ENTITIES           = '%d entities have been reversed.';
  IMPORTED_ENTITIES           = '%d entities have been imported.';
  TS_APP_REGISTERED           = 'Application is registered';
  TS_APP_UNREGISTERED         = 'Application has been removed';
  TS_APP_UNKNOWN              = 'Client ID doesn''t exist';
  TS_ACCESS_TOKEN_EXPIRE      = 'Access token expires at:';
  TS_USERS                    = 'Users:';
{$ENDREGION}

{$WARN SYMBOL_PLATFORM OFF}    // ERDA is mandatory & only available on Windows... I ignore these warnings

type
  EnumWindowsProc = function (Hwnd : THandle;Param:Pointer):Boolean;stdcall;
  TComponentType = (Input, Output);
  TfrmERS = class(TForm)
{$REGION 'Components'}
    pcERS: TPageControl;
    bbtnLoadEntities: TBitBtn;
    tsEntities: TTabSheet;
    stbERS: TStatusBar;
    lvEntities: TListView;
    odlgDiagram: TOpenDialog;
    tsRepository: TTabSheet;
    lbledRepositoryUsername: TLabeledEdit;
    bbtnRepositoryLogin: TBitBtn;
    bbtnRepositoryLogout: TBitBtn;
    gbRepositoryProjects: TGroupBox;
    gbRepositoryDiagrams: TGroupBox;
    pnlRepositoryCredentials: TPanel;
    pnlRepositoryProjectsDiagrams: TPanel;
    sptRepositoryProjectsDiagrams: TSplitter;
    lvRepositoryProjects: TListView;
    lvRepositoryDiagrams: TListView;
    lbledRepositoryActiveDirectory: TLabeledEdit;
    tsDataLineage: TTabSheet;
    cbDataFlows: TComboBox;
    lblDataflows: TLabel;
    pnlDataLineageDataFlow: TPanel;
    lvDataLineage: TListView;
    imglIcons: TImageList;
    tsDataDictionary: TTabSheet;
    bbtnDataDictionaryUserDataTypes: TBitBtn;
    lvDataDictionaryUserDataTypes: TListView;
    btnedRepositoryPassword: TButtonedEdit;
    lblRepositoryPassword: TLabel;
    tsCreate: TTabSheet;
    bbtnCreateModel: TBitBtn;
    cbRefreshERDA: TCheckBox;
    clrdlgCreate: TColorDialog;
    pnlColorEntities: TPanel;
    pnlColorBackground: TPanel;
    tsReverse: TTabSheet;
    gbReverseConnection: TGroupBox;
    lblReverseConnectionType: TLabel;
    lblReverseDBMSType: TLabel;
    lblReverseDatasource: TLabel;
    lblReverseUsername: TLabel;
    btnedReversePassword: TButtonedEdit;
    lblReversePassword: TLabel;
    lblReverseObjectOwner: TLabel;
    edtReverseUsername: TEdit;
    edtReverseDatasource: TEdit;
    cbReverseDBMSType: TComboBox;
    cbReverseConnectionType: TComboBox;
    Label7: TLabel;
    edtReverseDatabase: TEdit;
    edtReverseObjectOwner: TEdit;
    lblReverseDatabase: TLabel;
    bbtnReverse: TBitBtn;
    gbReverseInclude: TGroupBox;
    cbReverseUserTables: TCheckBox;
    cbReverseSystemTables: TCheckBox;
    cbReverseUserViews: TCheckBox;
    cbReverseSystemViews: TCheckBox;
    gbReverseOptions: TGroupBox;
    cbReverseInferPK: TCheckBox;
    cbReverseInferDomains: TCheckBox;
    lbledRepositoryServer: TLabeledEdit;
    tsTeamServer: TTabSheet;
    pcTS: TPageControl;
    tsRegistration: TTabSheet;
    tsAuthorization: TTabSheet;
    tsResources: TTabSheet;
    bbtnTSRegister: TBitBtn;
    btnedClientID: TButtonedEdit;
    btnedSecret: TButtonedEdit;
    btnedName: TButtonedEdit;
    btnedDescription: TButtonedEdit;
    btnedHome: TButtonedEdit;
    mmoTSRegister: TMemo;
    btnedTSRoot: TButtonedEdit;
    NetHTTPClientQuery: TNetHTTPClient;
    lblTSServerRoot: TLabel;
    lblTSClientID: TLabel;
    Label1: TLabel;
    lblTSApplicationName: TLabel;
    lblTSApplicationDescription: TLabel;
    lblTSCallbackURL: TLabel;
    bbtnTSDeleteApplication: TBitBtn;
    pnlTSCommonFields: TPanel;
    bbtnTSGetCode: TBitBtn;
    bbtnTSGetAccessToken: TBitBtn;
    lbledTSCode: TLabeledEdit;
    lbledTSAccessToken: TLabeledEdit;
    lbledTSRefreshToken: TLabeledEdit;
    pnlTSAccessToken: TPanel;
    mmoTSResources: TMemo;
    bbtnTSPeople: TBitBtn;
    bbtnTSGlossaries: TBitBtn;
    bbtnTSEntities: TBitBtn;
    lblDocLink: TLabel;
    bbtnExportImage: TBitBtn;
    bbtnImportSQL: TBitBtn;
    bbtnLayoutCircular: TBitBtn;
    odlgSQL: TOpenDialog;
    spdlgExport: TSavePictureDialog;
    cbDatabase: TComboBox;
    gbCreateFromCode: TGroupBox;
    gbImportSQL: TGroupBox;
    cbLayout: TComboBox;
    bbtnDataDictionaryAttachmentsGet: TBitBtn;
    pnlDataDictionary: TPanel;
    gbAttachments: TGroupBox;
    spbtnDataDictionaryAttachmentsGenerate: TSpeedButton;
    spedAttachmentsNumber: TSpinEdit;
    spedAttachmentsSplit: TSpinEdit;
    lblAttachmentsNumber: TLabel;
    lblAttachmentsSplit: TLabel;
    bbtnDataDictionarySecurityGet: TBitBtn;
    spbtnDataDictionarySecurityGenerate: TSpeedButton;
    bbtnTSGetAccessTokenWithAdmin: TBitBtn;
{$ENDREGION 'Components'}
    // Load the Entities from the current diagram
    procedure bbtnLoadEntitiesClick(Sender: TObject);
    // Display the Attributes & Table DDL for the double-clicked Entity
    procedure lvEntitiesDblClick(Sender: TObject);

    // Load User Datatypes from current Data Dictionary
    procedure bbtnDataDictionaryUserDataTypesClick(Sender: TObject);

    // Load Data Flows & their Transformations details
    procedure tsDataLineageShow(Sender: TObject);
    procedure cbDataFlowsChange(Sender: TObject);

    // Create a new diagram with Entities & Relationships
    procedure bbtnCreateModelClick(Sender: TObject);
    // Import SQL
    procedure bbtnImportSQLClick(Sender: TObject);
    // Try to change the layout sending keystrokes
    procedure bbtnLayoutCircularClick(Sender: TObject);
    // Export image
    procedure bbtnExportImageClick(Sender: TObject);

    // Reverse a database using the configuration set in the tab
    procedure bbtnReverseClick(Sender: TObject);

    // Connect/Disconnect from the Repository
    procedure tsRepositoryShow(Sender: TObject);
    procedure bbtnRepositoryLoginClick(Sender: TObject);
    procedure bbtnRepositoryLogoutClick(Sender: TObject);

    // Team Server REST API
    procedure tsTeamServerShow(Sender: TObject);
    procedure pcTSChange(Sender: TObject);
    procedure btnedGUIDLeftButtonClick(Sender: TObject);
    procedure btnedDeleteRightButtonClick(Sender: TObject);
    // Register an application to TS
    procedure bbtnTSRegisterClick(Sender: TObject);
    // Unregister an application from TS
    procedure bbtnTSDeleteApplicationClick(Sender: TObject);
    // Get an authorization code
    procedure bbtnTSGetCodeClick(Sender: TObject);
    // Get an access token
    procedure bbtnTSGetAccessTokenClick(Sender: TObject);
    // Get the list of TS users
    procedure bbtnTSPeopleClick(Sender: TObject);
    // Get the list of the glossaries
    procedure bbtnTSGlossariesClick(Sender: TObject);
    // Get the 10 "first" entities
    procedure bbtnTSEntitiesClick(Sender: TObject);

    // Initialize the application
    procedure FormCreate(Sender: TObject);

    // Misc
    procedure btnedPasswordRightButtonClick(Sender: TObject);
    procedure pnlColorsClick(Sender: TObject);
    procedure cbReverseConnectionTypeChange(Sender: TObject);
    procedure cbReverseDBMSTypeChange(Sender: TObject);
    procedure stbERSClick(Sender: TObject);
    procedure lblDocLinkClick(Sender: TObject);
    // Manage sort on column header click
    procedure lvEntitiesColumnClick(Sender: TObject; Column: TListColumn);
    procedure lvEntitiesCompare(Sender: TObject; Item1, Item2: TListItem; Data: Integer; var Compare: Integer);
    procedure bbtnDataDictionaryAttachmentsGetClick(Sender: TObject);
    procedure spbtnDataDictionaryAttachmentsGenerateClick(Sender: TObject);
    procedure bbtnDataDictionarySecurityGetClick(Sender: TObject);
    procedure spbtnDataDictionarySecurityGenerateClick(Sender: TObject);
    procedure bbtnTSGetAccessTokenWithAdminClick(Sender: TObject);
  private
    { Dclarations prives }
    app                  : ERSApplication;
    diag                 : ERSDiagram;
    models               : ERSModels;
    model                : ERSModel;
    submodel             : ERSSubModel;
    entities             : ERSEntities;
    entity               : ERSEntity;
    tables               : ERSEntities;
    table                : ERSEntity;
    projects             : ERSProjects;
    project              : ERSProject;
    bEntitySortDescending: Boolean;
    iEntitySortedColumn  : Integer;
    dERSVersion          : Double;
    function  GetTransformationType(tt: string): string;
    function  GetTransformationColumns(transformation: ITransformation; ComponentType: TComponentType): string;
    function  GetTable(tablename: string): ERSEntity;
    function  GUID: string;
    function  GetAttachmentDataType(datatype: Integer): string;
    procedure OAuth2_CodeRedirect(const AURL: string; var DoCloseWebView: boolean);
  public
    { Dclarations publiques }
  end;

var
  frmERS: TfrmERS;

implementation

{$R *.dfm}

uses frmREST.Authenticator.OAuth.WebForm;

var
  pidERS: Cardinal;

procedure TfrmERS.bbtnLoadEntitiesClick(Sender: TObject);
var
  cPrevious: TCursor;         // Current mouse cursor
  ovElement: OleVariant;      // To store an item
  iEnum    : IEnumVARIANT;    // To store all the items
  num      : LongWord;        // Item index
begin
  cPrevious     := Screen.Cursor;
  // The mouse cursor is an Hourglass during the loading
  Screen.Cursor := crHourGlass;

  // Get the current Diagram
  diag          := app.ActiveDiagram;

  if Assigned(diag) then
  begin
  // Get the current Model
    model := diag.ActiveModel;
    if Assigned(model) then
    begin
      // Check if the model is a physical one
      if not model.Logical then
      begin
        // Get all Models
        models := diag.Models;
        if Assigned(models) then
        begin
          // Get an IEnumVARIANT interface to loop through the Models
          iEnum := models._NewEnum as IEnumVARIANT;
//          iEnum.Reset;   // Restart from the first element

          // Get next Model
          while iEnum.Next(1, ovElement, num) = S_OK do
          begin
            // Cast the Model to its associated object
            model := IDispatch(ovElement) as ERSModel;
            if Assigned(model) then
            begin
              // Check if the model if a Logical one
              if model.Logical then
              begin
                // Set the Logical Model as the current one
                diag.SetActiveModel(model.Name);
                Break;
              end;
            end;
          end;
        end;
      end;

//      submodel := model.ActiveSubModel;

      // Load all the Entities
      entities := model.Entities;
      if Assigned(entities) then
      begin
        // Clear the ListView
        lvEntities.Items.Clear;

        // Get an IEnumVARIANT interface to loop through the Entities
        iEnum := entities._NewEnum as IEnumVARIANT;
//        iEnum.Reset;

        // Prevents updating of the list view until the EndUpdate method is called to speed up the loading
        lvEntities.Items.BeginUpdate;
        
        // Get next Entity
        while iEnum.Next(1, ovElement, num) = S_OK do
        begin
          // Cast the Entity to its associated object
          entity := IDispatch(ovElement) as ERSEntity;
          if Assigned(entity) then
          begin
            // Add a new line in the ListView with its details
            with lvEntities.Items.Add do
            begin
              ImageIndex := -1;
              Caption    := entity.EntityName; // Display the Entity name
              SubItems.Add(entity.TableName);  // Display the Table name
              SubItems.Add(entity.Owner);      // Display the owner
              SubItems.Add(entity.GUID);       // Hidden column used with the double-click
            end;
          end;
        end;
        // Reenables ListView repainting that was turned off with the BeginUpdate method above
        lvEntities.Items.EndUpdate;
      end;

      // Add the number of Entities in the Application title bar
      Self.Caption := Format(NB_ENTITIES, [Application.Title, model.Name, lvEntities.Items.Count]);
    end;
  end
  else
  begin
    // Ask the user if he/she wants to open a diagram as none are currently opened
    if MessageDlg(NO_DIAGRAM + sLineBreak + OPEN_DIAGRAM, TMsgDlgType.mtConfirmation, [TMsgDlgBtn.mbYes, TMsgDlgBtn.mbNo], 0) = mrYes then
    begin
      // Display the dialog to choose a file
      if odlgDiagram.Execute then
      begin
        Screen.Cursor := crHourGlass;
        Application.ProcessMessages;
        // Load the Diagram in ERDA
        if Assigned(app.OpenFile(odlgDiagram.FileName)) then
        begin
          Screen.Cursor := crHourGlass;
          Application.ProcessMessages;
          // Diagram has been opened, trying to load the entities once again
          bbtnLoadEntities.Click;
        end;
      end;
    end;
  end;

  // Put back the initial mouse cursor
  Screen.Cursor := cPrevious;
end;

procedure TfrmERS.lvEntitiesDblClick(Sender: TObject);
var
  cPrevious : TCursor;
  attributes: ERSAttributes;
  attribute : AttributeObj;
  attrs     : string;
  ovElement : OleVariant;
  iEnum     : IEnumVARIANT;
  num       : LongWord;
  wudc      : WhereUsedDataCollection;
  wud       : WhereUsedDataObj;
begin
  cPrevious     := Screen.Cursor;
  Screen.Cursor := crHourGlass;
  if Assigned(lvEntities.Selected) and Assigned(entities) then
  begin
    // Get the entity for the selected list view item
    entity := entities[lvEntities.Selected.SubItems[2]];

    if Assigned(entity) then
    begin
      // Get where the entity is used
      wudc  := entity.WhereUsedModelUsage;
      // Loop through the different Where Used
      iEnum := wudc._NewEnum as IEnumVARIANT;
      while iEnum.Next(1, ovElement, num) = S_OK do
      begin
        // Get a Where Used iten
        wud := IDispatch(ovElement) as WhereUsedDataObj;
        // Check if a Model ID & Entity ID are defined
        if Assigned(wud) and not VarIsNull(wud.ModelID) and not VarIsNull(wud.EntityID) then
        begin
          // Get the associated Table for the current Entity (to be able to get the TableDDL later)
          table := diag.Models.Item[wud.ModelID].Entities[wud.EntityID];
          // Check the table name is equal to the one from the entity
          if table.TableName = entity.TableName then
          begin
            // Found: exiting the loop
            Break;
          end;
        end;
      end;

      if not Assigned(table) then
      begin
        // if table has not been found using the WhereUsedModelUsage, try to find it with a local function
        table := GetTable(entity.TableName);
      end;

      // Check if the table has been found; no physical model = no table for example
      if Assigned(table) then
      begin
        // Get the attributes of the Table
        attributes := table.Attributes;
        if Assigned(attributes) then
        begin
          attrs := NB_ATTRIBUTES + IntToStr(entity.Attributes.Count) + sLineBreak;
          // Loop through the Attributes
          iEnum := attributes._NewEnum as IEnumVARIANT;
  //        iEnum.Reset;
          while iEnum.Next(1, ovElement, num) = S_OK do
          begin
            // Get an Attribute
            attribute := IDispatch(ovElement) as AttributeObj;
            if Assigned(attribute) then
            begin
              // Concatenate specific data of the Attribute
              attrs := attrs + IfThen(attribute.PrimaryKey, 'PK: ') + attribute.AttributeName + ' |' + attribute.Datatype + IfThen(attribute.DataLength <> -2, '(' + IntToStr(attribute.DataLength) + ')') + sLineBreak;
            end;
          end;
        end;
        // Display the Table Name, Definition, Attributes & DDL
        attrs := table.TableName + sLineBreak + table.Definition + sLineBreak + sLineBreak + attrs + sLineBreak + sLineBreak + table.TableDDL;
        MessageDlg(Trim(attrs), TMsgDlgType.mtInformation, [TMsgDlgBtn.mbOK], 0);
      end
      else
      begin
        // Entity doesn't have a table... Just displaying its name & definition
        MessageDlg(Trim(entity.TableName + sLineBreak + entity.Definition), TMsgDlgType.mtInformation, [TMsgDlgBtn.mbOK], 0);
      end;
    end;
  end;
  Screen.Cursor := cPrevious;
end;

function TfrmERS.GetAttachmentDataType(datatype: Integer): string;
begin
  case datatype of
    1:   Result := 'Boolean';
    2:   Result := 'Date';
    3:   Result := 'External File Path';
    4:   Result := 'Numeric';
    5:   Result := 'Text';
    6:   Result := 'TextList';
    7:   Result := 'Time';
    else Result := 'Unknown';
  end;
end;

procedure TfrmERS.bbtnDataDictionaryAttachmentsGetClick(Sender: TObject);
var
  cPrevious : TCursor;
  dictionary: IDictionary;
  ats       : IAttachmentTypes;
  at        : IAttachmentType;
  aas       : IAttachments;
  aa        : IAttachment;
  ovElement : OleVariant;
  iEnum     : IEnumVARIANT;
  num       : LongWord;
  ovElement2: OleVariant;
  iEnum2     : IEnumVARIANT;
  num2       : LongWord;
begin
  cPrevious     := Screen.Cursor;
  Screen.Cursor := crHourGlass;
  diag          := app.ActiveDiagram;

  lvDataDictionaryUserDataTypes.Items.Clear;

  if Assigned(diag) then
  begin
    dictionary := diag.Dictionary;
    if Assigned(dictionary) then
    begin
      ats  := dictionary.AttachmentTypes;

      iEnum := ats._NewEnum as IEnumVARIANT;
//      iEnum.Reset;
      while iEnum.Next(1, ovElement, num) = S_OK do
      begin
        at := IDispatch(ovElement) as IAttachmentType;
        if Assigned(at) then
        begin
          with lvDataDictionaryUserDataTypes.Items.Add do
          begin
            Caption := at.Name + ' | ' + at.Description;

            // Get Attchments for 1 Attachment Type
            aas := at.Attachments;
            iEnum2 := aas._NewEnum as IEnumVARIANT;
//            iEnum2.Reset;
            while iEnum2.Next(1, ovElement2, num2) = S_OK do
            begin
              aa := IDispatch(ovElement2) as IAttachment;
              if Assigned(aa) then
              begin
                with lvDataDictionaryUserDataTypes.Items.Add do
                begin
                  Caption := '  ' + aa.Name + ' | ' + GetAttachmentDataType(aa.Datatype);
                end;
              end;
            end;
          end;
        end;
      end;

      Self.Caption := Format(NB_ATTACHMENTS, [Application.Title, dictionary.Name, lvDataDictionaryUserDataTypes.Items.Count]);
    end
    else
    begin
      MessageDlg(NO_DICO, TMsgDlgType.mtWarning, [TMsgDlgBtn.mbOK], 0);
    end;
  end
  else
  begin
    if MessageDlg(NO_DIAGRAM + sLineBreak + OPEN_DIAGRAM, TMsgDlgType.mtConfirmation, [TMsgDlgBtn.mbYes, TMsgDlgBtn.mbNo], 0) = mrYes then
    begin
      if odlgDiagram.Execute then
      begin
        Screen.Cursor := crHourGlass;
        Application.ProcessMessages;
        if Assigned(app.OpenFile(odlgDiagram.FileName)) then
        begin
          Screen.Cursor := crHourGlass;
          Application.ProcessMessages;
          // Diagram has been opened, trying to load attachments once again
          bbtnDataDictionaryAttachmentsGet.Click;
        end;
      end;
    end;
  end;
  Screen.Cursor := cPrevious;
end;

procedure TfrmERS.bbtnDataDictionarySecurityGetClick(Sender: TObject);
var
  cPrevious : TCursor;
  dictionary: IDictionary;
  ats       : ISecurityTypes;
  at        : ISecurityType;
  aas       : ISecurityProperties;
  aa        : IDataSecurityProperty;
  ovElement : OleVariant;
  iEnum     : IEnumVARIANT;
  num       : LongWord;
  ovElement2: OleVariant;
  iEnum2     : IEnumVARIANT;
  num2       : LongWord;
begin
  cPrevious     := Screen.Cursor;
  Screen.Cursor := crHourGlass;
  diag          := app.ActiveDiagram;

  lvDataDictionaryUserDataTypes.Items.Clear;

  if Assigned(diag) then
  begin
    dictionary := diag.Dictionary;
    if Assigned(dictionary) then
    begin
      ats  := dictionary.SecurityTypes;

      iEnum := ats._NewEnum as IEnumVARIANT;
//      iEnum.Reset;
      while iEnum.Next(1, ovElement, num) = S_OK do
      begin
        at := IDispatch(ovElement) as ISecurityType;
        if Assigned(at) then
        begin
          with lvDataDictionaryUserDataTypes.Items.Add do
          begin
            Caption := at.Name + ' | ' + at.Description;

            // Get Attchments for 1 Attachment Type
            aas := at.SecurityProperties;
            iEnum2 := aas._NewEnum as IEnumVARIANT;
//            iEnum2.Reset;
            while iEnum2.Next(1, ovElement2, num2) = S_OK do
            begin
              aa := IDispatch(ovElement2) as IDataSecurityProperty;
              if Assigned(aa) then
              begin
                with lvDataDictionaryUserDataTypes.Items.Add do
                begin
                  Caption := '  ' + aa.Name + ' | ' + GetAttachmentDataType(aa.Datatype);
                end;
              end;
            end;
          end;
        end;
      end;

      Self.Caption := Format(NB_SECURITIES, [Application.Title, dictionary.Name, lvDataDictionaryUserDataTypes.Items.Count]);
    end
    else
    begin
      MessageDlg(NO_DICO, TMsgDlgType.mtWarning, [TMsgDlgBtn.mbOK], 0);
    end;
  end
  else
  begin
    if MessageDlg(NO_DIAGRAM + sLineBreak + OPEN_DIAGRAM, TMsgDlgType.mtConfirmation, [TMsgDlgBtn.mbYes, TMsgDlgBtn.mbNo], 0) = mrYes then
    begin
      if odlgDiagram.Execute then
      begin
        Screen.Cursor := crHourGlass;
        Application.ProcessMessages;
        if Assigned(app.OpenFile(odlgDiagram.FileName)) then
        begin
          Screen.Cursor := crHourGlass;
          Application.ProcessMessages;
          // Diagram has been opened, trying to load attachments once again
          bbtnDataDictionarySecurityGet.Click;
        end;
      end;
    end;
  end;
  Screen.Cursor := cPrevious;
end;

procedure TfrmERS.bbtnDataDictionaryUserDataTypesClick(Sender: TObject);
var
  cPrevious : TCursor;
  dictionary: IDictionary;
  udts      : IUserDatatypes;
  udt       : IUserDatatype;
  ovElement : OleVariant;
  iEnum     : IEnumVARIANT;
  num       : LongWord;
begin
  cPrevious     := Screen.Cursor;
  Screen.Cursor := crHourGlass;
  diag          := app.ActiveDiagram;

  if Assigned(diag) then
  begin
    dictionary := diag.Dictionary;
    if Assigned(dictionary) then
    begin
      lvDataDictionaryUserDataTypes.Items.Clear;

      udts  := dictionary.UserDatatypes;

      iEnum := udts._NewEnum as IEnumVARIANT;
//      iEnum.Reset;
      while iEnum.Next(1, ovElement, num) = S_OK do
      begin
        udt := IDispatch(ovElement) as IUserDatatype;
        if Assigned(udt) then
        begin
          with lvDataDictionaryUserDataTypes.Items.Add do
          begin
            Caption := udt.Name;
          end;
        end;
      end;

      Self.Caption := Format(NB_UDTS, [Application.Title, dictionary.Name, lvDataDictionaryUserDataTypes.Items.Count]);
    end
    else
    begin
      MessageDlg(NO_DICO, TMsgDlgType.mtWarning, [TMsgDlgBtn.mbOK], 0);
    end;
  end
  else
  begin
    if MessageDlg(NO_DIAGRAM + sLineBreak + OPEN_DIAGRAM, TMsgDlgType.mtConfirmation, [TMsgDlgBtn.mbYes, TMsgDlgBtn.mbNo], 0) = mrYes then
    begin
      if odlgDiagram.Execute then
      begin
        Screen.Cursor := crHourGlass;
        Application.ProcessMessages;
        if Assigned(app.OpenFile(odlgDiagram.FileName)) then
        begin
          Screen.Cursor := crHourGlass;
          Application.ProcessMessages;
          // Diagram has been opened, trying to load UDT once again
          bbtnDataDictionaryUserDataTypes.Click;
        end;
      end;
    end;
  end;
  Screen.Cursor := cPrevious;
end;

procedure TfrmERS.tsDataLineageShow(Sender: TObject);
var
  cPrevious: TCursor;
  ovElement: OleVariant;
  iEnum    : IEnumVARIANT;
  num      : LongWord;
  tasks    : ITasks;
  task     : iTask;
  slTasks  : TStringList;
begin
  if cbDataFlows.ItemIndex = -1 then
  begin
    cPrevious     := Screen.Cursor;
    Screen.Cursor := crHourGlass;
    if Assigned(app) then
    begin
      diag := app.ActiveDiagram;

      if Assigned(diag) then
      begin
        tasks := diag.DataFlows;
        if tasks.Count > 0 then
        begin
          slTasks := TStringList.Create;
          try
            iEnum := tasks._NewEnum as IEnumVARIANT;
//            iEnum.Reset;
            while iEnum.Next(1, ovElement, num) = S_OK do
            begin
              task := IDispatch(ovElement) as ITask;
              if Assigned(task) then
              begin
                slTasks.Add(task.Name);
              end;
            end;
            cbDataFlows.Items.Clear;
            cbDataFlows.Items.AddStrings(slTasks);
          finally
            slTasks.Free;
          end;
        end
        else
        begin
          cbDataFlows.Hint := NO_DATAFLOW;
        end;
      end
      else
      begin
        cbDataFlows.Hint := NO_DIAGRAM;
      end;
    end;
    Screen.Cursor := cPrevious;
  end;
end;

procedure TfrmERS.cbDataFlowsChange(Sender: TObject);
var
  cPrevious      : TCursor;
  dataflow       : ITask;
  transformations: ITransformations;
  transformation : ITransformation;
  ovElement      : OleVariant;
  iEnum          : IEnumVARIANT;
  num            : LongWord;
begin
  cPrevious     := Screen.Cursor;
  Screen.Cursor := crHourGlass;
  if (cbDataFlows.ItemIndex <> -1) and Assigned(diag) then
  begin
    lvDataLineage.Items.Clear;
    dataflow := diag.DataFlows.Item[cbDataFlows.Text];
    if Assigned(dataflow) then
    begin
      transformations := dataflow.Transformations;
      if Assigned(transformations) then
      begin
        iEnum := transformations._NewEnum as IEnumVARIANT;
//        iEnum.Reset;
        while iEnum.Next(1, ovElement, num) = S_OK do
        begin
          transformation := IDispatch(ovElement) as ITransformation;
          if Assigned(transformation) then
          begin
            with lvDataLineage.Items.Add do
            begin
              Caption := transformation.Name;
              SubItems.Add(GetTransformationType(transformation.type_));
              SubItems.Add(GetTransformationColumns(transformation, TComponentType.Input));
              SubItems.Add(transformation.BusinessDefinition);
              SubItems.Add(transformation.CodeDefinition);
              SubItems.Add(GetTransformationColumns(transformation, TComponentType.Output));
            end;
          end;
        end;
      end;
    end;
  end;
  Screen.Cursor := cPrevious;
end;

function TfrmERS.GetTransformationType(tt: string): string;
begin
  Result := tt;
  if Result = '' then
  begin
    Result := DEFAULT_TRANSFORMATION_TYPE;
  end;
end;

function TfrmERS.GetTransformationColumns(transformation: ITransformation; ComponentType: TComponentType): string;
var
	sModelName : string;
	sTableName : string;
	sColumnName: string;
  ovElement  : OleVariant;
  iEnum      : IEnumVARIANT;
  num        : LongWord;
	transFields: ITransformationFields;
	transField : ITransformationField;
  dlModel    : DataLineageSource;
  dlTable    : DataLineageTable;
  dlColumn   : DataLineageColumn;
  dlView     : DataLineageView;
  dlViewField: DataLineageViewField;
  view       : ERSView;
  vwColumn   : ViewField;
  attribute  : IAttribute;
begin
  Result := '';
  case ComponentType of
    Input:
    begin
      TransFields := transformation.LineageInputs;
    end;
    Output:
    begin
      TransFields := transformation.LineageOutputs;
    end;
  end;

  if Assigned(TransFields) then
  begin
    iEnum := TransFields._NewEnum as IEnumVARIANT;
//    iEnum.Reset;
    while iEnum.Next(1, ovElement, num) = S_OK do
    begin
      TransField := IDispatch(ovElement) as ITransformationField;
      if Assigned(TransField) then
      begin
        model := diag.Models.Item[transField.SourceModelID];
        if Assigned(model) then
        begin
          sModelName := model.Name;
          case TransField.SourceObjectType of
            5: // transformation field is an attribute
            begin
              entity      := model.Entities.Item[transField.SourceParentID];
              sTableName  := entity.TableName;
              attribute   := entity.Attributes.Item[transField.SourceObjectID];
              sColumnName := attribute.ColumnName;
            end;
            17: // transformation field is a view column
            begin
              view        := model.Views.Item[transField.SourceParentID];
              sTableName  := view.Name;
              vwColumn    := view.ViewFields.Item[transField.SourceObjectID];
              sColumnName := vwColumn.ParentColumnName;
            end
            else
            begin
              // Debug.Print "ERROR:  Output type not defined."
            end;
          end;
        end
        else
        begin
          dlModel    := diag.DataLineageSources.Item[transField.SourceModelID];
          sModelName := dlModel.Name;
          case transField.SourceObjectType of
            5: // trans field is an attribute
            begin
              dlTable     := dlModel.DataLineageTables.Item[transField.SourceParentID];
              sTableName  := dlTable.Name;
              dlColumn    := dlTable.DataLineageColumns.Item[transField.SourceObjectID];
              sColumnName := dlColumn.ColumnName;
            end;
            17: // trans field is a view column
            begin
              dlView      := dlModel.DataLineageViews.Item[transField.SourceParentID];
              sTableName  := dlView.Name;
              dlViewField := dlView.DataLineageViewFields.Item[transField.SourceObjectID];
              sColumnName := dlViewField.ParentColumnName;
            end
            else
            begin
              // Debug.Print "ERROR:  Output type not defined."
            end;
          end;
        end;
        Result := Result + sModelName + '.' + sTableName + '.' + sColumnName + ',' + ' ';
      end;
    end;
  end;

  Result := Trim(Result);
  if RightStr(Result, 1) = ',' then
  begin
    Result := Copy(Result, 1, Length(Result) - 1);
  end;
end;

function TfrmERS.GetTable(tablename: string): ERSEntity;
var
  ovModels   : OleVariant;
  ovTables   : OleVariant;
  iEnumModels: IEnumVARIANT;
  numModels  : LongWord;
  iEnumTables: IEnumVARIANT;
  numTables  : LongWord;
begin
  Result := nil;

  if Assigned(diag) then
  begin
    // Browse the physical models to find the table
    models := diag.Models;
    if Assigned(models) then
    begin
      iEnumModels := models._NewEnum as IEnumVARIANT;
//      iEnumModels.Reset;
      while iEnumModels.Next(1, ovModels, numModels) = S_OK do
      begin
        model := IDispatch(ovModels) as ERSModel;
        if Assigned(model) then
        begin
          if not model.Logical then
          begin
            diag.SetActiveModel(model.Name);
            application.ProcessMessages;
//            ShowMessage('Searching in ' + model.Name);
            tables := model.Entities;
            if Assigned(tables) then
            begin
              iEnumTables := tables._NewEnum as IEnumVARIANT;
//              iEnumTables.Reset;
              while iEnumTables.Next(1, ovTables, numTables) = S_OK do
              begin
                table := IDispatch(ovTables) as ERSEntity;
                if Assigned(table) then
                begin
                  if table.TableName = tablename then
                  begin
                    Result := table;
                    Break;
                  end;
                end;
              end;
            end;
          end;
        end;
      end;
    end;
  end;
end;

procedure TfrmERS.bbtnCreateModelClick(Sender: TObject);
const
  ENTITIES_X_POSITION  : array[0..23] of Integer = (171, 171, 373, 375, 565, 565, 757, 949, 757, 949, 750, 949, 1141, 1340, 1141, 1141, 1340, 1340, 1539, 1539, 1738, 1738, 1738, 1539);
  ENTITIES_Y_POSITION  : array[0..23] of Integer = (189, 571, 189, 571, 284, 474, 189, 189, 379, 380, 569, 571, 189, 189, 380, 571, 571, 380, 571, 189, 189, 571, 380, 380);
  RELATIONSHIPS_PARENTS: array[0..17] of Integer = (1, 3, 3, 4, 5, 8,  7, 11,  9, 16, 13, 14, 18, 15, 19, 20, 21, 23);
  RELATIONSHIPS_CHILDS : array[0..17] of Integer = (2, 4, 5, 6, 6, 7, 11, 12, 10, 13, 14, 18, 15, 17, 20, 21, 22, 24);
var
  iLoop    : Integer;
  ed       : EntityDisplay;
//  rs       : Relationship;
  cPrevious: TCursor;
begin
  cPrevious     := Screen.Cursor;
  Screen.Cursor := crHourGlass;

  if not cbRefreshERDA.Checked then
  begin
    // Disable the screen update in ERDA
    app.EnableScreenUpdate(False);
  end;

  try
    // Create a new diagram
    diag          := app.NewDiagram;
    // Get the current model
    model         := diag.ActiveModel;
    // Create a new submodel
    submodel      := model.SubModels.Add('IDERA');

    // Define the background color of the submodel
    submodel.DiagramBackgroundColor := pnlColorBackground.Color;
    // Loop to add several entities
    for iLoop := Low(ENTITIES_X_POSITION) to High(ENTITIES_X_POSITION) do
    begin
      // Add an entity at a specific position
      entity := model.Entities.Add(ENTITIES_X_POSITION[iLoop], ENTITIES_Y_POSITION[iLoop]);
      // Add an Attribute which is a primary key
      entity.Attributes.Add('ID', True).Datatype := 'INTEGER';
      // Add another attribute
      with entity.Attributes.Add('Description', False) do
      begin
        // Change the data of the new Attribute
        Datatype   := 'VARCHAR';
        DataLength := 50;
      end;
      // Get a pointer to the graphical entity
      ed                 := submodel.EntityDisplays.Item[entity.EntityName];
      // Change the color of this entity
      ed.BackgroundColor := pnlColorEntities.Color;
    end;

    // Loop to add relationships
    for iLoop := Low(RELATIONSHIPS_PARENTS) to High(RELATIONSHIPS_PARENTS) do
    begin
      // Add a non-specific relationship
      model.Relationships.Add(RELATIONSHIPS_PARENTS[iLoop], RELATIONSHIPS_CHILDS[iLoop], 2); // This is the type of the relationship. The relationship types are: Identifying - 0, NonIdentifying - 1, NonSpecific - 2, NonIdentifying Optional - 3, Containment - 8(MongoDB Only). DATATYPE: Integer.
    end;

    // Define the zoom percentage for the submodel
    submodel.ZoomFactor := 70;

    MessageDlg(Format(ENTITIES_CREATED, [model.Entities.Count, model.Relationships.Count]), TMsgDlgType.mtInformation, [TMsgDlgBtn.mbOK], 0);

  finally
    if not cbRefreshERDA.Checked then
    begin
      // Enable the screen update in ERDA
      app.EnableScreenUpdate(True);
    end;
  end;

  Screen.Cursor := cPrevious;
end;

procedure TfrmERS.bbtnImportSQLClick(Sender: TObject);
var
  cPrevious: TCursor;
begin
  odlgSQL.FileName := ExtractFileName(odlgSQL.FileName);
  if odlgSQL.Execute then
  begin
    cPrevious     := Screen.Cursor;
    Screen.Cursor := crHourGlass;

    // Import SQL
    diag := app.ImportSQLFile(odlgSQL.FileName, cbDatabase.Text);

    if Assigned(diag) then
    begin
      model := diag.ActiveModel;
      if Assigned(model) then
      begin
        entities := model.Entities;
        if Assigned(entities) then
        begin
          // Import is finished; Display the number of entities generated
          MessageDlg(Format(IMPORTED_ENTITIES, [entities.Count]), TMsgDlgType.mtInformation, [TMsgDlgBtn.mbOK], 0);
        end;
      end;
    end
    else
    begin
      // An error occured during the import; Display the error
      MessageDlg(app.GetLastErrorString, TMsgDlgType.mtWarning, [TMsgDlgBtn.mbOK], 0);
    end;

    Screen.Cursor := cPrevious;
  end;
end;

function GetPIDbyProcessName(processName:String):integer;
var
  GotProcess: Boolean;
  tempHandle: THandle;
  procE     : TProcessEntry32;
begin
  tempHandle   := CreateToolHelp32SnapShot(TH32CS_SNAPALL, 0);
  procE.dwSize := SizeOf(procE);
  GotProcess   := Process32First(tempHandle, procE);
  {$B-}
    if GotProcess and (procE.szExeFile <> processName) then
      repeat GotProcess := Process32Next(tempHandle, procE);
      until (not GotProcess) or (procE.szExeFile = processName);
  {$B+}

  if GotProcess then
    Result := procE.th32ProcessID
  else
    Result := 0; // process not found in running process list

  CloseHandle(tempHandle);
end;

function LoopWindows(Hwnd : THandle;Param:Pointer):Boolean;stdcall;
var
  Text, WndClass: string;
  len           : Integer;
  pid           : Cardinal;
  cLayout       : Char;
  iLoop, iMax   : Integer;
begin
  SetLength(Text, 25);
  GetWindowText(Hwnd, Pchar(Text), 25);
  SetLength(WndClass, 17);
  len := GetClassName(Hwnd, PChar(WndClass), Length(WndClass));
  if len=0 then
    RaiseLastOSError;
  SetLength(WndClass, len);
  Result := True;
  if (WndClass <> 'tooltips_class32') and (WndClass <> '#32770') then
  begin
    GetWindowThreadProcessId(Hwnd, pid);
    if (pid = pidERS) then
      if StartsText('ER/Studio Data Architect', Text) then
      begin
        SendMessage(Hwnd, WM_SYSCOMMAND, SC_MAXIMIZE, 0);
        SetForegroundWindow(Hwnd);
        Sleep(100);
        Application.ProcessMessages;

        if frmERS.dERSVersion < 18.5 then
        begin
          // Till version 18.4
          cLayout := frmERS.cbLayout.Text[1];
          // Send a keyboard shortcut to the focused application: Alt L C : Layout Circular
          keybd_event(VK_LMENU, 0, KEYEVENTF_EXTENDEDKEY, 0);
          keybd_event(VkKeyScan('L'), 0, KEYEVENTF_EXTENDEDKEY, 0);
          keybd_event(VkKeyScan(cLayout), 0, KEYEVENTF_EXTENDEDKEY, 0);
          Sleep(15);
          keybd_event(VkKeyScan(cLayout), 0, KEYEVENTF_KEYUP, 0);
          keybd_event(VkKeyScan('L'), 0, KEYEVENTF_KEYUP, 0);
          keybd_event(VK_LMENU, 0, KEYEVENTF_KEYUP, 0);
        end
        else
        begin
          // From version 18.5
          iMax := frmERS.cbLayout.ItemIndex;
          keybd_event(VK_LMENU, 0, KEYEVENTF_EXTENDEDKEY, 0);
          keybd_event(VkKeyScan('D'), 0, KEYEVENTF_EXTENDEDKEY, 0);
          Sleep(15);
          keybd_event(VkKeyScan('D'), 0, KEYEVENTF_KEYUP, 0);
          Sleep(250);
          keybd_event(VkKeyScan('L'), 0, KEYEVENTF_EXTENDEDKEY, 0);
          Sleep(15);
          keybd_event(VkKeyScan('L'), 0, KEYEVENTF_KEYUP, 0);

          for iLoop := 1 to iMax do
          begin
            keybd_event(VK_DOWN, 0, KEYEVENTF_EXTENDEDKEY, 0);
            Sleep(15);
            keybd_event(VK_DOWN, 0, KEYEVENTF_KEYUP, 0);
            Sleep(15);
          end;

          keybd_event(VK_RETURN, 0, KEYEVENTF_EXTENDEDKEY, 0);
          Sleep(15);
          keybd_event(VK_RETURN, 0, KEYEVENTF_KEYUP, 0);
          Sleep(15);
          keybd_event(VK_LMENU, 0, KEYEVENTF_KEYUP, 0);
        end;

        Result := False;
      end;
  end;
end;

procedure TfrmERS.bbtnLayoutCircularClick(Sender: TObject);
var
  WindowProc : EnumWindowsProc;
begin
  pidERS := GetPIDbyProcessName('ERSTUDIO.exe');

  WindowProc := LoopWindows;
  EnumWindows(@WindowProc, 0);
end;

procedure TfrmERS.bbtnExportImageClick(Sender: TObject);
var
  cPrevious: TCursor;         // Current mouse cursor
begin
  cPrevious     := Screen.Cursor;
  // The mouse cursor is an Hourglass during the loading
  Screen.Cursor := crHourGlass;

  // Get the current Diagram
  diag          := app.ActiveDiagram;

  if Assigned(diag) then
  begin
    // Get the current Model
    model := diag.ActiveModel;
    if Assigned(model) then
    begin
      // Get the current SubModel
      submodel := model.ActiveSubModel;
      if Assigned(submodel) then
      begin
        spdlgExport.FileName := ExtractFileName(spdlgExport.FileName);
        // Ask the user to specify the filename/type of the image
        if spdlgExport.Execute then
        begin
          submodel.ExportImageOptions.FileName := spdlgExport.FileName;
          // Indicates what type of image to generate. The values are either 0 = BMP, 1 = JPG, 2 = EMF, 3 = GIF or 4 = PNG. DATATYPE: Integer.
          case spdlgExport.FilterIndex of
            2:    submodel.ExportImageOptions.ImageType := 3; // GIF
            4..5: submodel.ExportImageOptions.ImageType := 1; // JPG
            6:    submodel.ExportImageOptions.ImageType := 0; // BMP
            7:    submodel.ExportImageOptions.ImageType := 2; // EMF
            else
                  submodel.ExportImageOptions.ImageType := 4; // PNG
          end;
          // Export the image
          submodel.ExportImageOptions.ExportImage;
        end;
      end;
    end;
  end
  else
  begin
    // Ask the user if he/she wants to open a diagram as none are currently opened
    if MessageDlg(NO_DIAGRAM + sLineBreak + OPEN_DIAGRAM, TMsgDlgType.mtConfirmation, [TMsgDlgBtn.mbYes, TMsgDlgBtn.mbNo], 0) = mrYes then
    begin
      // Display the dialog to choose a file
      if odlgDiagram.Execute then
      begin
        Screen.Cursor := crHourGlass;
        Application.ProcessMessages;
        // Load the Diagram in ERDA
        if Assigned(app.OpenFile(odlgDiagram.FileName)) then
        begin
          Screen.Cursor := crHourGlass;
          Application.ProcessMessages;
          // Diagram has been opened, trying to export the image once again
          bbtnExportImage.Click;
        end;
      end;
    end;
  end;

  // Put back the initial mouse cursor
  Screen.Cursor := cPrevious;
end;

procedure TfrmERS.bbtnReverseClick(Sender: TObject);
var
  cPrevious      : TCursor;
  reverseEngineer: ERSReverseEngineer;
begin
  cPrevious     := Screen.Cursor;
  Screen.Cursor := crHourGlass;

  if edtReverseObjectOwner.Text = '' then
  begin
    // If Object Owner is empty, take the User Name
    edtReverseObjectOwner.Text := edtReverseUsername.Text;
  end;

  reverseEngineer                := app.ReverseEngineerObject;
  reverseEngineer.ConnectionType := cbReverseConnectionType.Text;
  reverseEngineer.DBMSType       := cbReverseDBMSType.Text;
  reverseEngineer.Datasource     := edtReverseDatasource.Text;
  reverseEngineer.ConnectString  := reverseEngineer.Datasource;
  reverseEngineer.Username       := edtReverseUsername.Text;
  reverseEngineer.Password       := btnedReversePassword.Text;
  reverseEngineer.Database       := edtReverseDatabase.Text;
  reverseEngineer.ObjectOwner    := edtReverseObjectOwner.Text;
  reverseEngineer.UserTables     := cbReverseUserTables.Checked;
  reverseEngineer.SystemTables   := cbReverseSystemTables.Checked;
  reverseEngineer.UserViews      := cbReverseUserViews.Checked;
  reverseEngineer.SystemViews    := cbReverseSystemViews.Checked;
  reverseEngineer.InferPK        := cbReverseInferPK.Checked;
  reverseEngineer.InferDomains   := cbReverseInferDomains.Checked;

  // Reverse-engineer the Database
  diag := reverseEngineer.DoReverseEngineer;
  if Assigned(diag) then
  begin
    model := diag.ActiveModel;
    if Assigned(model) then
    begin
      entities := model.Entities;
      if Assigned(entities) then
      begin
        // Reverse is finished; Display the number of entities generated
        MessageDlg(Format(REVERSED_ENTITIES, [entities.Count]), TMsgDlgType.mtInformation, [TMsgDlgBtn.mbOK], 0);
      end;
    end;
  end
  else
  begin
    // An error occured during the reverse; Display the error
    MessageDlg(app.GetLastErrorString, TMsgDlgType.mtWarning, [TMsgDlgBtn.mbOK], 0);
  end;

  Screen.Cursor := cPrevious;
end;

procedure TfrmERS.tsRepositoryShow(Sender: TObject);
const
  REGISTRY_ROOT  = 'HKEY_CURRENT_USER\';
  REPOSITORY_KEY = 'Repository';
  SERVER_VALUE   = 'RepoServer Home Dir';
  LAST_USER      = 'LastLoggedInUser';
var
  reg: TRegistry;
begin
  if Assigned(app) then
  begin
    bbtnRepositoryLogout.Enabled        := Length(app.CurrentUser) > 0;
    bbtnRepositoryLogin.Enabled         := not bbtnRepositoryLogout.Enabled;

    lbledRepositoryActiveDirectory.Text := app.RepoActiveDirectory;

    // Get the Repository server from the Windows Registry
    reg := TRegistry.Create(KEY_READ);
    try
      if reg.OpenKeyReadOnly(StringReplace(app.GetRegistryKey, REGISTRY_ROOT, '', []) + '\' + REPOSITORY_KEY) then
      begin
        lbledRepositoryServer.Text := reg.ReadString(SERVER_VALUE);
        if lbledRepositoryUsername.Text = '' then
        begin
          lbledRepositoryUsername.Text := reg.ReadString(LAST_USER);
        end;
        reg.CloseKey;
      end;
    finally
      reg.Free;
    end;
  end;
end;

procedure TfrmERS.bbtnRepositoryLoginClick(Sender: TObject);
var
  cPrevious: TCursor;
  iEnum    : IEnumVARIANT;
  ovElement: OleVariant;
  num      : LongWord;
  so       : StringObjects;
begin
  cPrevious     := Screen.Cursor;
  Screen.Cursor := crHourGlass;
  lvRepositoryProjects.Items.Clear;
  lvRepositoryDiagrams.Items.Clear;

  if Assigned(app) then
  begin
    if app.RepoLogin(lbledRepositoryUsername.Text, btnedRepositoryPassword.Text) then
    begin
      bbtnRepositoryLogout.Enabled        := True;
    end
    else
    begin
      bbtnRepositoryLogout.Enabled := False;
      MessageDlg(NO_REPO_CONNECT + sLineBreak + sLineBreak + app.GetLastErrorString, TMsgDlgType.mtWarning, [TMsgDlgBtn.mbOK], 0);
    end;
    bbtnRepositoryLogin.Enabled := not bbtnRepositoryLogout.Enabled;
  end;

  if bbtnRepositoryLogout.Enabled then
  begin
    projects := app.RepoProjects;
    if Assigned(projects) then
    begin
      iEnum := projects._NewEnum as IEnumVARIANT;
//      iEnum.Reset;
      while iEnum.Next(1, ovElement, num) = S_OK do
      begin
        project := IDispatch(ovElement) as ERSProject;
        if Assigned(project) then
        begin
          with lvRepositoryProjects.Items.Add do
          begin
            Caption := project.Name;
            SubItems.Add(project.Description);
          end;
        end;
      end;
    end;

    so := app.RepoDiagrams;
    if Assigned(so) then
    begin
      iEnum := so._NewEnum as IEnumVARIANT;
//      iEnum.Reset;
      while iEnum.Next(1, ovElement, num) = S_OK do
      begin
        with lvRepositoryDiagrams.Items.Add do
        begin
          Caption := ovElement.StringValue;
        end;
      end;
    end;
  end;
  Screen.Cursor := cPrevious;
end;

procedure TfrmERS.bbtnRepositoryLogoutClick(Sender: TObject);
var
  cPrevious  : TCursor;
begin
  cPrevious     := Screen.Cursor;
  Screen.Cursor := crHourGlass;
  if Assigned(app) then
  begin
    bbtnRepositoryLogout.Enabled := False;
    bbtnRepositoryLogin.Enabled  := not bbtnRepositoryLogout.Enabled;
    app.RepoLogout;
  end;
  Screen.Cursor := cPrevious;
end;

procedure TfrmERS.tsTeamServerShow(Sender: TObject);
const
  REGISTRY_ROOT  = 'HKEY_CURRENT_USER\';
  REPOSITORY_KEY = 'Repository';
  SERVER_VALUE   = 'Portal Address';
var
  reg: TRegistry;
begin
  if btnedTSRoot.Text = '' then
  begin
    if Assigned(app) then
    begin
      // Get the TS server from the Windows Registry
      reg := TRegistry.Create(KEY_READ);
      try
        if reg.OpenKeyReadOnly(StringReplace(app.GetRegistryKey, REGISTRY_ROOT, '', []) + '\' + REPOSITORY_KEY) then
        begin
          btnedTSRoot.Text := reg.ReadString(SERVER_VALUE);
          reg.CloseKey;
        end;
      finally
        reg.Free;
      end;
    end;
  end;
end;

procedure TfrmERS.pcTSChange(Sender: TObject);
const
  links: array[0..2] of string = (
    'http://docwiki.embarcadero.com/TeamServer/ERStudio/en/Registering_Your_API_Client_Application_in_Team_Server',
    'http://docwiki.embarcadero.com/TeamServer/ERStudio/en/Using_the_Web_Server_Authorization_Flow',
    'http://docwiki.embarcadero.com/TeamServer/ERStudio/en/API_Reference');
begin
  // Manage the visibility of common fields between the different tabs
  pnlTSCommonFields.Visible := not (pcTS.ActivePage = tsResources);
  pnlTSAccessToken.Visible  := not (pcTS.ActivePage = tsRegistration);

  // Display different help page links depending of the current tab
  lblDocLink.Caption        := links[pcTS.TabIndex];
end;

procedure TfrmERS.btnedGUIDLeftButtonClick(Sender: TObject);
begin
  // Generate a GUID in the current edit
  if Sender is TButtonedEdit then
  begin
    TButtonedEdit(Sender).Text := GUID;
  end;
end;

procedure TfrmERS.btnedDeleteRightButtonClick(Sender: TObject);
begin
  // Clear the current edit
  if Sender is TButtonedEdit then
  begin
    TButtonedEdit(Sender).Text := '';
  end;
end;

procedure TfrmERS.bbtnTSRegisterClick(Sender: TObject);
var
  jo       : TJSONObject;
  jv       : TJSONValue;
  sURL     : string;
  resp     : IHTTPResponse;
  ssJSON   : TStringStream;
  cPrevious: TCursor;
begin
  cPrevious     := Screen.Cursor;
  Screen.Cursor := crHourGlass;

  if btnedClientID.Text = '' then
  begin
    btnedClientID.Text := GUID;
  end;

  if btnedSecret.Text = '' then
  begin
    btnedSecret.Text := GUID;
  end;

  // JSON object with the mandatory values
  jo            := TJSONObject.Create;
  try
    jo.AddPair('clientId', btnedClientID.Text);
    jo.AddPair('secret', btnedSecret.Text);
    jo.AddPair('name', btnedName.Text);
    jo.AddPair('description', btnedDescription.Text);
    jo.AddPair('home', btnedHome.Text);
    jo.AddPair('image', 'https://www.idera.com/favicon.ico');
    jo.AddPair('clientType', TJSONNumber.Create(1));
    jo.AddPair('nativeType', TJSONNumber.Create(0));

    // Display the JSON we just created
    mmoTSRegister.Lines.Text := jo.Format(2);
    Application.ProcessMessages;

    if not EndsStr('/', btnedTSRoot.Text) then
    begin
      btnedTSRoot.Text := btnedTSRoot.Text + '/';
    end;

    // URL to register an application with TS
    sURL := btnedTSRoot.Text + 'api/v1/clients';

    NetHTTPClientQuery.ContentType := 'application/json';
    ssJSON := TStringStream.Create(jo.ToJSON);
    try
      // Send a POST query to register the application
      resp := NetHTTPClientQuery.Post(sURL, ssJSON);
    finally
      ssJSON.Free;
    end;

    // 200: Success
    if resp.StatusCode = 200 then
    begin
      jv := TJSONObject.ParseJSONValue(resp.ContentAsString);
      try
        // Show the JSON returned by TS
        mmoTSRegister.Text := jv.Format(2);
      finally
        jv.Free;
      end;
      MessageDlg(TS_APP_REGISTERED, TMsgDlgType.mtInformation, [TMsgDlgBtn.mbOK], 0);
    end
    else
    begin
      MessageDlg(IntToStr(resp.StatusCode) + resp.StatusText, TMsgDlgType.mtWarning, [TMsgDlgBtn.mbOK], 0);
    end;
  finally
    jo.Free;
    Screen.Cursor := cPrevious;
  end;
end;

procedure TfrmERS.bbtnTSDeleteApplicationClick(Sender: TObject);
var
  sURL     : string;
  resp     : IHTTPResponse;
  cPrevious: TCursor;
begin
  cPrevious     := Screen.Cursor;
  Screen.Cursor := crHourGlass;
  try
    if not EndsStr('/', btnedTSRoot.Text) then
    begin
      btnedTSRoot.Text := btnedTSRoot.Text + '/';
    end;

    // URL to check/unregister an application with TS
    sURL := btnedTSRoot.Text + 'api/v1/clients/' + btnedClientID.Text;

    NetHTTPClientQuery.ContentType := 'application/json';
    // Unregister the application
    resp := NetHTTPClientQuery.Delete(sURL);

    if resp.StatusCode = 200 then
    begin
      mmoTSRegister.Text := resp.ContentAsString;
      MessageDlg(TS_APP_UNREGISTERED, TMsgDlgType.mtInformation, [TMsgDlgBtn.mbOK], 0);
    end
    else if resp.StatusCode = 404 then
    begin
      mmoTSRegister.Text := TS_APP_UNKNOWN;
      MessageDlg(IntToStr(resp.StatusCode) + resp.StatusText, TMsgDlgType.mtWarning, [TMsgDlgBtn.mbOK], 0);
    end
    else
    begin
      MessageDlg(IntToStr(resp.StatusCode) + resp.StatusText, TMsgDlgType.mtWarning, [TMsgDlgBtn.mbOK], 0);
    end;
  finally
    Screen.Cursor := cPrevious;
  end;
end;

procedure TfrmERS.bbtnTSGetCodeClick(Sender: TObject);
var
  wv  : Tfrm_MyOAuthWebForm;
  sURL: string;
begin
  if not EndsStr('/', btnedTSRoot.Text) then
  begin
    btnedTSRoot.Text := btnedTSRoot.Text + '/';
  end;

  // URL to request a code for the application
  sURL := btnedTSRoot.Text + 'api/oauth/authorize?response_type=code&client_id=' + URIEncode(btnedClientID.Text)
        + '&redirect_uri=' + URIEncode(btnedHome.Text)
        + '&scope=' + URIEncode('read+write')
        + '&state=' + URIEncode('wTest');

  // Open a window with a browser to allow the user to connect to TS and authorize the application
  wv                 := Tfrm_MyOAuthWebForm.Create(self);
  wv.OnAfterRedirect := OAuth2_CodeRedirect; // Method which checks if the 'code' has been returned by TS
  wv.ShowWithURL(sURL);
  wv.Release;
end;

procedure TfrmERS.bbtnTSGetAccessTokenClick(Sender: TObject);
var
  sURL     : string;
  resp     : IHTTPResponse;
  JSONValue: TJSONValue;
  dtExpire : TDateTime;
begin
  // URL to request an Access Token with the code, ClientID & secret
  sURL := btnedTSRoot.Text + 'api/oauth/token?code=' + lbledTSCode.Text + '&client_id=' + URIEncode(btnedClientID.Text)
        + '&client_secret=' + URIEncode(btnedSecret.Text)
        + '&grant_type=authorization_code'
        + '&redirect_uri=' + URIEncode(btnedHome.Text);

  // Send the request to TS
  resp := NetHTTPClientQuery.Get(sURL);

  if resp.StatusCode = 200 then
  begin
    JSONValue                := TJSONObject.ParseJSONValue(resp.ContentAsString);
    try
      lbledTSAccessToken.Text  := JSONValue.GetValue<string>('access_token');
      lbledTSRefreshToken.Text := JSONValue.GetValue<string>('refresh_token');
      dtExpire                 := IncSecond(Now, JSONValue.GetValue<Integer>('expires_in'));
      lbledTSAccessToken.Hint  := TS_ACCESS_TOKEN_EXPIRE + sLineBreak + FormatDateTime('dddddd tt', dtExpire);
    finally
      JSONValue.Free;
    end;

    bbtnTSPeople.Enabled     := True;
    bbtnTSGlossaries.Enabled := True;
    bbtnTSEntities.Enabled   := True;
  end;
end;

procedure TfrmERS.bbtnTSGetAccessTokenWithAdminClick(Sender: TObject);
var
  sURL     : string;
  resp     : IHTTPResponse;
  JSONValue: TJSONValue;
  dtExpire : TDateTime;
begin
  // I don't recommend to use this method as you must provide the password in the URL!!!

  // URL to request an Access Token with the User/Password, ClientID & secret
  sURL := btnedTSRoot.Text + 'api/oauth/token?username=Admin&password=Admin&client_id=' + URIEncode(btnedClientID.Text)
        + '&client_secret=' + URIEncode(btnedSecret.Text)
        + '&grant_type=password';

  // Send the request to TS
  resp := NetHTTPClientQuery.Get(sURL);

  if resp.StatusCode = 200 then
  begin
    JSONValue                := TJSONObject.ParseJSONValue(resp.ContentAsString);
    try
      lbledTSAccessToken.Text  := JSONValue.GetValue<string>('access_token');
      lbledTSRefreshToken.Text := JSONValue.GetValue<string>('refresh_token');
      dtExpire                 := IncSecond(Now, JSONValue.GetValue<Integer>('expires_in'));
      lbledTSAccessToken.Hint  := TS_ACCESS_TOKEN_EXPIRE + sLineBreak + FormatDateTime('dddddd tt', dtExpire);
    finally
      JSONValue.Free;
    end;

    bbtnTSPeople.Enabled     := True;
    bbtnTSGlossaries.Enabled := True;
    bbtnTSEntities.Enabled   := True;
  end;
end;

procedure TfrmERS.bbtnTSPeopleClick(Sender: TObject);
var
  sURL     : string;
  resp     : IHTTPResponse;
  JSONValue: TJSONValue;
  users    : TJSONArray;
  user     : TJSONValue;
  sUsers   : string;
begin
// http://docwiki.embarcadero.com/TeamServer/ERStudio/en/API_Reference
  sURL := btnedTSRoot.Text + 'api/v1/people?access_token=' + lbledTSAccessToken.Text;

  resp := NetHTTPClientQuery.Get(sURL);

  JSONValue := TJSONObject.ParseJSONValue(resp.ContentAsString);

  try
    users := JSONValue.GetValue<TJSONArray>('people');

    sUsers := '';

    mmoTSResources.Text := TS_USERS + sLineBreak;
    // Iterate the array of users
    for user in users do
    begin
      mmoTSResources.Lines.Add(user.GetValue<string>('displayName'));
    end;

    mmoTSResources.Lines.Add('');
    mmoTSResources.Lines.Add('');
    mmoTSResources.Lines.Add(JSONValue.Format(2));
  finally
    JSONValue.Free;
  end;
end;

procedure TfrmERS.bbtnTSGlossariesClick(Sender: TObject);
var
  sURL     : string;
  resp     : IHTTPResponse;
  JSONValue: TJSONValue;
//  slParam: TStringList;
begin
// http://docwiki.embarcadero.com/TeamServer/ERStudio/en/API_Reference
  sURL      := btnedTSRoot.Text + 'api/v1/businessglossaries?access_token=' + lbledTSAccessToken.Text;
  resp      := NetHTTPClientQuery.Get(sURL);
  JSONValue := TJSONObject.ParseJSONValue(resp.ContentAsString);
  try
    mmoTSResources.Lines.Add(JSONValue.Format(2));
  finally
    JSONValue.Free;
  end;
end;

procedure TfrmERS.bbtnTSEntitiesClick(Sender: TObject);
var
  sURL     : string;
  resp     : IHTTPResponse;
  JSONValue: TJSONValue;
begin
  // http://docwiki.embarcadero.com/TeamServer/ERStudio/en/Browsing_Resources_Using_the_API#Paginating_Results
  sURL      := btnedTSRoot.Text + 'api/v1/entities?limit=10&access_token=' + lbledTSAccessToken.Text;
  resp      := NetHTTPClientQuery.Get(sURL);
  JSONValue := TJSONObject.ParseJSONValue(resp.ContentAsString);
  try
    mmoTSResources.Text := JSONValue.Format(2);
  finally
    JSONValue.Free;
  end;
end;

procedure TfrmERS.OAuth2_CodeRedirect(const AURL: string; var DoCloseWebView: boolean);
var
  iPos  : Integer;
  sToken: string;
begin
  // Check if the parameter 'code' is present and get its value
  iPos := Pos('code=', AURL);
  if (iPos > 0) then
  begin
    sToken := Copy(AURL, iPos + 5, Length(AURL));
    // Check if there are other parameters to only keep the code value
    iPos   := Pos('&', sToken);
    if (iPos > 0) then
    begin
      sToken := Copy(sToken, 1, Pred(iPos));
    end;

    lbledTSCode.Text := sToken;
    if (sToken <> '') then
    begin
      DoCloseWebView               := True;
      bbtnTSGetAccessToken.Enabled := True;
    end;
  end;
end;

procedure TfrmERS.FormCreate(Sender: TObject);
begin
  Self.Caption          := Application.Title;
  bEntitySortDescending := False;
  iEntitySortedColumn   := -1;
  Randomize;

  try
    // Connect/Launch to ERDA
    app := CoERSApplication.Create;

    // Get the version from the instance
    stbERS.SimpleText := app.ERSVersion + ' ' + app.ERSFullVersion;
    dERSVersion := StrToFloatDef(StringReplace(Copy(frmERS.app.ERSFullVersion, 1, Pos('.', frmERS.app.ERSFullVersion, 4) - 1), '.', FormatSettings.DecimalSeparator, []), -1);

    stbERS.Enabled    := True;
  except on E: Exception do
    begin
      pcERS.Enabled := False;
      MessageDlg(NO_ERDA, TMsgDlgType.mtWarning, [TMsgDlgBtn.mbOK], 0);
    end;
  end;
end;

{$REGION 'Misc'}
procedure TfrmERS.btnedPasswordRightButtonClick(Sender: TObject);
var
  bShowed: Boolean;
begin
  if Sender is TButtonedEdit then
  begin
    with TButtonedEdit(Sender).RightButton do
    begin
      bShowed := ImageIndex = 12;
      if bShowed then
      begin
        ImageIndex := 8;
        TButtonedEdit(Sender).PasswordChar := '*';
      end
      else
      begin
        ImageIndex := 12;
        TButtonedEdit(Sender).PasswordChar := #0;
      end;
      DisabledImageIndex := ImageIndex + 1;;
      HotImageIndex      := ImageIndex + 2;
      PressedImageIndex  := ImageIndex + 3;
    end;
  end;
end;

procedure TfrmERS.pnlColorsClick(Sender: TObject);
begin
  if Sender is TPanel then
  begin
    clrdlgCreate.Color := TPanel(Sender).Color;
    if clrdlgCreate.Execute then
    begin
      TPanel(Sender).Color := clrdlgCreate.Color;
    end;
  end;
end;

procedure TfrmERS.spbtnDataDictionaryAttachmentsGenerateClick(Sender: TObject);
var
  iLoop     : Integer;
  cPrevious : TCursor;
  dictionary: IDictionary;
  ats       : IAttachmentTypes;
  at        : IAttachmentType;
  iNB       : Integer;
  iPadding  : Integer;
  iSplit    : Integer;
begin
  cPrevious     := Screen.Cursor;
  Screen.Cursor := crHourGlass;
  diag          := app.ActiveDiagram;

  if spbtnDataDictionaryAttachmentsGenerate.Down then
  begin
    if Assigned(diag) then
    begin
      dictionary := diag.Dictionary;
      if Assigned(dictionary) then
      begin
        iNB      := 0;
        iPadding := Length(IntToStr(spedAttachmentsNumber.Value));
        iSplit   := spedAttachmentsSplit.Value;
        if iSplit = 0 then
        begin
          iSplit := spedAttachmentsNumber.Value;
        end
        else if iSplit > spedAttachmentsNumber.Value then
        begin
          iSplit                     := spedAttachmentsNumber.Value;
          spedAttachmentsSplit.Value := 0;
        end;

        ats  := dictionary.AttachmentTypes;

        at := ats.Add(Format('%.*d', [iPadding, 1]) + ' - ' + Format('%.*d', [iPadding, iSplit]), '');

        try
          app.EnableScreenUpdateEx(False, False); // only works on Data Model treeview.. useless for DD (Data Dictionary)

          for iLoop := 1 to spedAttachmentsNumber.Value do
          begin
            at.Attachments.Add(Format('%.*d', [iPadding, iLoop]), '', '', 5);  // Create an attachment with Text DataType
            Inc(iNB);

            if (iLoop mod iSplit = 0) then
            begin
              if iLoop < spedAttachmentsNumber.Value then
              begin
                at := ats.Add(Format('%.*d', [iPadding, (iLoop + 1)]) + ' - ' + Format('%.*d', [iPadding, (iLoop + iSplit)]), '');
              end;

              lvDataDictionaryUserDataTypes.Items.Clear;
              lvDataDictionaryUserDataTypes.Items.Add.Caption := IntToStr(iLoop);
              Application.ProcessMessages;
            end;
            if not spbtnDataDictionaryAttachmentsGenerate.Down then
            begin
              Break;
            end;
          end;
        finally
            app.EnableScreenUpdateEx(True, True);
            spbtnDataDictionaryAttachmentsGenerate.Down := False;
        end;
        Self.Caption := Format(NB_ATTACHMENTS_CREATED, [Application.Title, dictionary.Name, iNB]);
      end
      else
      begin
        MessageDlg(NO_DICO, TMsgDlgType.mtWarning, [TMsgDlgBtn.mbOK], 0);
      end;
    end
    else
    begin
      if MessageDlg(NO_DIAGRAM + sLineBreak + OPEN_DIAGRAM, TMsgDlgType.mtConfirmation, [TMsgDlgBtn.mbYes, TMsgDlgBtn.mbNo], 0) = mrYes then
      begin
        if odlgDiagram.Execute then
        begin
          Screen.Cursor := crHourGlass;
          Application.ProcessMessages;
          if Assigned(app.OpenFile(odlgDiagram.FileName)) then
          begin
            Screen.Cursor := crHourGlass;
            Application.ProcessMessages;
            // Diagram has been opened, trying to load UDT once again
            spbtnDataDictionaryAttachmentsGenerate.Click;
          end;
        end;
      end;
    end;
  end
  else
  begin
    app.EnableScreenUpdateEx(True, True);
  end;

  Screen.Cursor := cPrevious;
end;

procedure TfrmERS.spbtnDataDictionarySecurityGenerateClick(Sender: TObject);
var
  iLoop     : Integer;
  cPrevious : TCursor;
  dictionary: IDictionary;
  ats       : ISecurityTypes;
  at        : ISecurityType;
  iNB       : Integer;
  iPadding  : Integer;
  iSplit    : Integer;
begin
  cPrevious     := Screen.Cursor;
  Screen.Cursor := crHourGlass;
  diag          := app.ActiveDiagram;

  if spbtnDataDictionarySecurityGenerate.Down then
  begin
    if Assigned(diag) then
    begin
      dictionary := diag.Dictionary;
      if Assigned(dictionary) then
      begin
        iNB      := 0;
        iPadding := Length(IntToStr(spedAttachmentsNumber.Value));
        iSplit   := spedAttachmentsSplit.Value;
        if iSplit = 0 then
        begin
          iSplit := spedAttachmentsNumber.Value;
        end
        else if iSplit > spedAttachmentsNumber.Value then
        begin
          iSplit                     := spedAttachmentsNumber.Value;
          spedAttachmentsSplit.Value := 0;
        end;

        ats  := dictionary.SecurityTypes;

        at := ats.Add(Format('DSI: %.*d', [iPadding, 1]) + ' - ' + Format('%.*d', [iPadding, iSplit]), '');

        try
          app.EnableScreenUpdateEx(False, False); // only works on Data Model treeview.. useless for DD (Data Dictionary)

          for iLoop := 1 to spedAttachmentsNumber.Value do
          begin
            at.SecurityProperties.Add(Format('%.*d', [iPadding, iLoop]), '', '', 5);  // Create an attachment with Text DataType
            Inc(iNB);

            if (iLoop mod iSplit = 0) then
            begin
              if iLoop < spedAttachmentsNumber.Value then
              begin
                at := ats.Add(Format('DSI: %.*d', [iPadding, (iLoop + 1)]) + ' - ' + Format('%.*d', [iPadding, (iLoop + iSplit)]), '');
              end;

              lvDataDictionaryUserDataTypes.Items.Clear;
              lvDataDictionaryUserDataTypes.Items.Add.Caption := IntToStr(iLoop);
              Application.ProcessMessages;
            end;
            if not spbtnDataDictionarySecurityGenerate.Down then
            begin
              Break;
            end;
          end;
        finally
            app.EnableScreenUpdateEx(True, True);
            spbtnDataDictionaryAttachmentsGenerate.Down := False;
        end;
        Self.Caption := Format(NB_ATTACHMENTS_CREATED, [Application.Title, dictionary.Name, iNB]);
      end
      else
      begin
        MessageDlg(NO_DICO, TMsgDlgType.mtWarning, [TMsgDlgBtn.mbOK], 0);
      end;
    end
    else
    begin
      if MessageDlg(NO_DIAGRAM + sLineBreak + OPEN_DIAGRAM, TMsgDlgType.mtConfirmation, [TMsgDlgBtn.mbYes, TMsgDlgBtn.mbNo], 0) = mrYes then
      begin
        if odlgDiagram.Execute then
        begin
          Screen.Cursor := crHourGlass;
          Application.ProcessMessages;
          if Assigned(app.OpenFile(odlgDiagram.FileName)) then
          begin
            Screen.Cursor := crHourGlass;
            Application.ProcessMessages;
            // Diagram has been opened, trying to load UDT once again
            spbtnDataDictionaryAttachmentsGenerate.Click;
          end;
        end;
      end;
    end;
  end
  else
  begin
    app.EnableScreenUpdateEx(True, True);
  end;

  Screen.Cursor := cPrevious;
end;

procedure TfrmERS.cbReverseConnectionTypeChange(Sender: TObject);
begin
  cbReverseDBMSType.Enabled  := cbReverseConnectionType.ItemIndex = 0;
  lblReverseDBMSType.Enabled := cbReverseDBMSType.Enabled;
  if cbReverseDBMSType.Enabled then
  begin
    edtReverseDatasource.TextHint := 'Server name or connection string';
  end
  else
  begin
    edtReverseDatasource.TextHint := 'ODBC datasource name';
  end;
  cbReverseDBMSTypeChange(Sender);
end;

procedure TfrmERS.cbReverseDBMSTypeChange(Sender: TObject);
begin
  edtReverseDatabase.Enabled := ((cbReverseConnectionType.ItemIndex = 0) and ((cbReverseDBMSType.ItemIndex = 1) or (cbReverseDBMSType.ItemIndex = 2)))
                              or (cbReverseConnectionType.ItemIndex = 1);
  lblReverseDatabase.Enabled := edtReverseDatabase.Enabled;
end;

procedure TfrmERS.stbERSClick(Sender: TObject);
begin
  if Assigned(app) and (app.GetLastErrorCode <> 0) then
  begin
    MessageDlg(Format('%s: %s', [app.GetLastErrorCode, app.GetLastErrorString]), TMsgDlgType.mtInformation, [TMsgDlgBtn.mbOK], 0);
  end
  else
  begin
    Beep;
  end;
end;

function TfrmERS.GUID: string;
var
  uid: TGuid;
begin
  Result := '';
  if CreateGuid(uid) = S_OK then
  begin
    Result := Copy(GuidToString(uid), 2, 36);
  end;
end;

procedure TfrmERS.lblDocLinkClick(Sender: TObject);
begin
  if Sender is TLabel then
  begin
    ShellExecute(Self.Handle, 'OPEN', pwidechar(TLabel(Sender).Caption), '', '', SW_SHOWNORMAL);
  end;
end;
{$ENDREGION 'Misc'}

{$REGION 'Header sort'}
procedure TfrmERS.lvEntitiesColumnClick(Sender: TObject; Column: TListColumn);
var
  Header: HWND;
  Item  : THDItem;
begin
  Header := ListView_GetHeader(lvEntities.Handle);
  ZeroMemory(@Item, SizeOf(Item));
  Item.Mask := HDI_FORMAT;

  // Clear the previous arrow
  Header_GetItem(Header, iEntitySortedColumn, Item);
  Item.fmt := Item.fmt and not (HDF_SORTUP or HDF_SORTDOWN);//remove both flags
  Header_SetItem(Header, iEntitySortedColumn, Item);

  if Column.Index = iEntitySortedColumn then
  begin
    bEntitySortDescending := not bEntitySortDescending;
  end
  else
  begin
    iEntitySortedColumn   := Column.Index;
  end;

  // Get the new column
  Header_GetItem(Header, iEntitySortedColumn, Item);
  Item.fmt := Item.fmt and not (HDF_SORTUP or HDF_SORTDOWN); // remove both flags

  if bEntitySortDescending then
  begin
    Item.fmt := Item.fmt or HDF_SORTDOWN; // include the sort ascending flag
  end
  else
  begin
    Item.fmt := Item.fmt or HDF_SORTUP;   // include the sort descending flag
  end;
  Header_SetItem(Header, iEntitySortedColumn, Item);

  with TListView(Sender) do
  begin
    Items.BeginUpdate;
    AlphaSort;
    Items.EndUpdate;
  end;
end;

procedure TfrmERS.lvEntitiesCompare(Sender: TObject; Item1, Item2: TListItem; Data: Integer; var Compare: Integer);
begin
  if iEntitySortedColumn = 0 then
  begin
    Compare := CompareText(Item1.Caption, Item2.Caption)
  end
  else
  begin
    Compare := CompareText(Item1.SubItems[iEntitySortedColumn - 1], Item2.SubItems[iEntitySortedColumn - 1]);
  end;

  if bEntitySortDescending then
  begin
    Compare := -Compare;
  end;
end;
{$ENDREGION 'Header sort'}

end.
